=== modified file 'django/newforms/extras/widgets.py'
--- django/newforms/extras/widgets.py	2007-02-13 16:11:28 +0000
+++ django/newforms/extras/widgets.py	2007-05-16 20:06:05 +0000
@@ -2,9 +2,10 @@
 Extra HTML Widget classes
 """
 
+import datetime
+
 from django.newforms.widgets import Widget, Select
 from django.utils.dates import MONTHS
-import datetime
 
 __all__ = ('SelectDateWidget',)
 

=== modified file 'django/newforms/fields.py'
--- django/newforms/fields.py	2007-05-07 16:38:08 +0000
+++ django/newforms/fields.py	2007-05-16 20:06:58 +0000
@@ -2,13 +2,15 @@
 Field classes
 """
 
+import datetime
+import re
+import time
+
 from django.utils.translation import gettext
 from django.utils.encoding import smart_unicode
+
 from util import ErrorList, ValidationError
 from widgets import TextInput, PasswordInput, HiddenInput, MultipleHiddenInput, CheckboxInput, Select, NullBooleanSelect, SelectMultiple
-import datetime
-import re
-import time
 
 __all__ = (
     'Field', 'CharField', 'IntegerField',

=== modified file 'django/newforms/forms.py'
--- django/newforms/forms.py	2007-05-15 19:21:20 +0000
+++ django/newforms/forms.py	2007-05-16 20:07:16 +0000
@@ -2,13 +2,15 @@
 Form classes
 """
 
-from django.utils.datastructures import SortedDict, MultiValueDict
+import copy
+
+from django.utils.datastructures import SortedDict
 from django.utils.html import escape
 from django.utils.encoding import StrAndUnicode
+
 from fields import Field
-from widgets import TextInput, Textarea, HiddenInput, MultipleHiddenInput
+from widgets import TextInput, Textarea
 from util import flatatt, ErrorDict, ErrorList, ValidationError
-import copy
 
 __all__ = ('BaseForm', 'Form')
 

=== modified file 'django/newforms/models.py'
--- django/newforms/models.py	2007-05-15 19:21:20 +0000
+++ django/newforms/models.py	2007-05-16 20:08:54 +0000
@@ -4,13 +4,16 @@
 """
 
 from django.utils.translation import gettext
+
 from util import ValidationError
-from forms import BaseForm, DeclarativeFieldsMetaclass, SortedDictFromList
+from forms import BaseForm, SortedDictFromList
 from fields import Field, ChoiceField
 from widgets import Select, SelectMultiple, MultipleHiddenInput
 
-__all__ = ('save_instance', 'form_for_model', 'form_for_instance', 'form_for_fields',
-           'ModelChoiceField', 'ModelMultipleChoiceField')
+__all__ = (
+    'save_instance', 'form_for_model', 'form_for_instance', 'form_for_fields',
+    'ModelChoiceField', 'ModelMultipleChoiceField'
+)
 
 def save_instance(form, instance, fields=None, fail_message='saved', commit=True):
     """

=== modified file 'django/newforms/util.py'
--- django/newforms/util.py	2007-04-09 21:05:36 +0000
+++ django/newforms/util.py	2007-05-16 20:12:28 +0000
@@ -1,6 +1,4 @@
-from django.conf import settings
 from django.utils.html import escape
-from django.utils.functional import Promise, lazy
 from django.utils.encoding import smart_unicode
 
 # Converts a dictionary to a single string with key="value", XML-style with

=== modified file 'django/newforms/widgets.py'
--- django/newforms/widgets.py	2007-05-07 16:38:08 +0000
+++ django/newforms/widgets.py	2007-05-16 20:13:46 +0000
@@ -2,24 +2,26 @@
 HTML Widget classes
 """
 
-__all__ = (
-    'Widget', 'TextInput', 'PasswordInput', 'HiddenInput', 'MultipleHiddenInput',
-    'FileInput', 'Textarea', 'CheckboxInput',
-    'Select', 'NullBooleanSelect', 'SelectMultiple', 'RadioSelect', 'CheckboxSelectMultiple',
-    'MultiWidget', 'SplitDateTimeWidget',
-)
+try:
+    set # Only available in Python 2.4+
+except NameError:
+    from sets import Set as set # Python 2.3 fallback
+from itertools import chain
 
-from util import flatatt
 from django.utils.datastructures import MultiValueDict
 from django.utils.html import escape
 from django.utils.translation import gettext
 from django.utils.encoding import StrAndUnicode, smart_unicode
-from itertools import chain
-
-try:
-    set # Only available in Python 2.4+
-except NameError:
-    from sets import Set as set # Python 2.3 fallback
+
+from util import flatatt
+
+__all__ = (
+    'Widget', 'TextInput', 'PasswordInput',
+    'HiddenInput', 'MultipleHiddenInput',
+    'FileInput', 'Textarea', 'CheckboxInput',
+    'Select', 'NullBooleanSelect', 'SelectMultiple', 'RadioSelect',
+    'CheckboxSelectMultiple', 'MultiWidget', 'SplitDateTimeWidget',
+)
 
 class Widget(object):
     is_hidden = False          # Determines whether this corresponds to an <input type="hidden">.