Index: django/contrib/databrowse/plugins/calendars.py
===================================================================
--- django/contrib/databrowse/plugins/calendars.py	(revision 5656)
+++ django/contrib/databrowse/plugins/calendars.py	(working copy)
@@ -5,6 +5,7 @@
 from django.shortcuts import render_to_response
 from django.utils.text import capfirst
 from django.utils.translation import get_date_formats
+from django.template import RequestContext
 from django.views.generic import date_based
 from django.utils.encoding import force_unicode
 import datetime
@@ -63,23 +64,51 @@
         return render_to_response('databrowse/calendar_homepage.html', {'root_url': self.site.root_url, 'model': easy_model, 'field_list': field_list})
 
     def calendar_view(self, request, field, year=None, month=None, day=None):
-        easy_model = EasyModel(self.site, self.model)
-        extra_context = {'root_url': self.site.root_url, 'model': easy_model, 'field': field}
-        if day is not None:
-            # TODO: The objects in this template should be EasyInstances
-            return date_based.archive_day(request, year, month, day, self.model.objects.all(), field.name,
-                template_name='databrowse/calendar_day.html', allow_empty=False, allow_future=True,
-                extra_context=extra_context)
-        elif month is not None:
-            return date_based.archive_month(request, year, month, self.model.objects.all(), field.name,
-                template_name='databrowse/calendar_month.html', allow_empty=False, allow_future=True,
-                extra_context=extra_context)
-        elif year is not None:
-            return date_based.archive_year(request, year, self.model.objects.all(), field.name,
-                template_name='databrowse/calendar_year.html', allow_empty=False, allow_future=True,
-                extra_context=extra_context)
+        page = 0
+        if request.has_key('page'):
+            page = request.GET['page']
+        easy_model = EasyModel(self.site, self.model, paginate_by = 100, page = page)
+        context = {'model': easy_model, 'field': field, 'root_url' : self.site.root_url}
+        if day is not None and day != "objects":
+            context['year'] = year
+            context['month'] = month
+            context['day'] = day
+            query = {
+                "%s__day" % field.name : int(day),
+                "%s__month" % field.name : int(time.strftime('%m', time.strptime(month, '%B'))),
+                "%s__year" % field.name : int(year),
+            }
+            context['object_list'] = easy_model.objects(**query)
+            template_name = "databrowse/calendar_fordate.html"
+        elif month is not None and month != "objects":
+            context['year'] = year
+            context['month'] = month
+            query = {
+                "%s__month" % field.name : int(time.strftime('%m', time.strptime(month, '%B'))),
+                "%s__year" % field.name : int(year),
+            }
+            if day == "objects":
+                context['object_list'] = easy_model.objects(**query)
+                template_name = "databrowse/calendar_fordate.html"
+            else:
+                context['date_list'] = self.model.objects.filter(**query).dates(field.name, 'day')
+                template_name = "databrowse/calendar_daterange.html"
+        elif year is not None and year != "objects":
+            context['year'] = year
+            query = {"%s__year" % field.name : int(year)}
+            if month == "objects":
+                context['object_list'] = easy_model.objects(**query)
+                template_name = "databrowse/calendar_fordate.html"
+            else:
+                context['date_list'] = self.model.objects.filter(**query).dates(field.name, 'month')
+                template_name = "databrowse/calendar_daterange.html"
         else:
-            return date_based.archive_index(request, self.model.objects.all(), field.name,
-                template_name='databrowse/calendar_main.html', allow_empty=True, allow_future=True,
-                extra_context=extra_context)
+            context = { 'model' : easy_model, 'field' : field }
+            if year == "objects":
+                context['object_list'] = easy_model.objects()
+                template_name = "databrowse/calendar_fordate.html"
+            else:
+                context['date_list'] = self.model.objects.all().dates(field.name, 'year')
+                template_name = "databrowse/calendar_daterange.html"
+        return render_to_response(template_name, context, context_instance=RequestContext(request))
         assert False, ('%s, %s, %s, %s' % (field, year, month, day))
Index: django/contrib/databrowse/plugins/fieldchoices.py
===================================================================
--- django/contrib/databrowse/plugins/fieldchoices.py	(revision 5656)
+++ django/contrib/databrowse/plugins/fieldchoices.py	(working copy)
@@ -65,10 +65,19 @@
         return render_to_response('databrowse/fieldchoice_homepage.html', {'root_url': self.site.root_url, 'model': easy_model, 'field_list': field_list})
 
     def field_view(self, request, field, value=None):
-        easy_model = EasyModel(self.site, self.model)
+        page = 0
+        if request.has_key('page'):
+            page = int(request.GET['page'])
+        easy_model = EasyModel(self.site, self.model, paginate_by = 100, page = page)
         easy_field = easy_model.field(field.name)
         if value is not None:
             obj_list = easy_model.objects(**{field.name: value})
             return render_to_response('databrowse/fieldchoice_detail.html', {'root_url': self.site.root_url, 'model': easy_model, 'field': easy_field, 'value': value, 'object_list': obj_list})
-        obj_list = [v[field.name] for v in self.model._default_manager.distinct().order_by(field.name).values(field.name)]
-        return render_to_response('databrowse/fieldchoice_list.html', {'root_url': self.site.root_url, 'model': easy_model, 'field': easy_field, 'object_list': obj_list})
+        op = ObjectPaginator(self.model._default_manager.distinct().order_by(field.name), 100)
+        results = op.get_page(page)
+        pagination_dict = {
+            "current_page" : page,
+            "pages" : op.pages,
+        }
+        obj_list = [getattr(v, field.name) for v in results]
+        return render_to_response('databrowse/fieldchoice_list.html', {'root_url': self.site.root_url, 'model': easy_model, 'field': easy_field, 'object_list': obj_list, "pagination" : pagination_dict})
Index: django/contrib/databrowse/datastructures.py
===================================================================
--- django/contrib/databrowse/datastructures.py	(revision 5656)
+++ django/contrib/databrowse/datastructures.py	(working copy)
@@ -7,17 +7,20 @@
 from django.utils import dateformat
 from django.utils.text import capfirst
 from django.utils.translation import get_date_formats
+from django.core.paginator import ObjectPaginator, InvalidPage
 from django.utils.encoding import smart_unicode, smart_str, iri_to_uri
 
 EMPTY_VALUE = '(None)'
 
 class EasyModel(object):
-    def __init__(self, site, model):
+    def __init__(self, site, model, paginate_by = None, page = 0):
         self.site = site
         self.model = model
         self.model_list = site.registry.keys()
         self.verbose_name = model._meta.verbose_name
         self.verbose_name_plural = model._meta.verbose_name_plural
+        self.paginate_by, self.page = paginate_by, page
+        self.pagination = None
 
     def __repr__(self):
         return '<EasyModel for %s>' % smart_str(self.model._meta.object_name)
@@ -29,10 +32,22 @@
     def url(self):
         return '%s%s/%s/' % (self.site.root_url, self.model._meta.app_label, self.model._meta.module_name)
 
-    def objects(self, **kwargs):
-        for obj in self.model._default_manager.filter(**kwargs):
+    def objects_from_queryset(self, qs):
+        if self.paginate_by is not None:
+            op = ObjectPaginator(qs, self.paginate_by)
+            results = op.get_page(self.page)
+            self.pagination = {
+                u"pages" : op.pages,
+                u"current_page" : int(self.page),
+            }
+        else:
+            results = qs
+        for obj in results:
             yield EasyInstance(self, obj)
 
+    def objects(self, **kwargs):
+        return self.objects_from_queryset(self.model._default_manager.filter(**kwargs))
+
     def object_by_pk(self, pk):
         return EasyInstance(self, self.model._default_manager.get(pk=pk))
 
Index: django/contrib/databrowse/templatetags/databrowse.py
===================================================================
--- django/contrib/databrowse/templatetags/databrowse.py	(revision 0)
+++ django/contrib/databrowse/templatetags/databrowse.py	(revision 0)
@@ -0,0 +1,53 @@
+from django import template
+from django.template import resolve_variable
+
+register = template.Library()
+
+def letterlimit(value, arg):
+    try:
+        cutoff = int(arg)
+        return "%s%s" % (str(value)[:cutoff], '...')
+    except Exception, e:
+        return value
+
+def do_pagination(parser, token):
+    try:
+        tag_name, pagination_dict_instance, width = token.split_contents()
+    except ValueError:
+        raise template.TemplateSyntaxError, "%r tag requires a double argument" % token.contents.split()[0]
+    try:
+        width_int = int(width)
+    except:
+        raise template.TemplateSyntaxError, "%r tag's second argument must be an integer" % token.contents.split()[0]
+    return PaginationNode(pagination_dict_instance, width_int)
+
+class PaginationNode(template.Node):
+    def __init__(self, context_key, width):
+        self.context_key = context_key
+        self.width = width
+    def render(self, context):
+        to_return = "<div id=\"pagination\">"
+        link_str = "<a href=\"./?page=%d\">[%d]</a>"
+        try:
+            pagination_dict = resolve_variable(self.context_key, context)
+            if pagination_dict['pages'] < 2:
+                to_return = ''
+            else:
+                for page in xrange(pagination_dict['pages']):
+                    if page == pagination_dict['current_page']:
+                        to_return = to_return + ("<a href=\"./?page=%d\" class=\"bold\">[%d]</a>" % (page, page))
+                    elif page < (self.width + 1) or page > (pagination_dict['pages'] - self.width - 2):
+                        to_return = to_return + (link_str % (page, page))
+                    elif page == pagination_dict['current_page'] - self.width - 1:
+                        to_return = to_return + "..."
+                    elif page == pagination_dict['current_page'] + self.width + 1:
+                        to_return = to_return + "..."
+                    elif (page >= pagination_dict['current_page'] - self.width) and (page <= pagination_dict['current_page'] + self.width):
+                        to_return = to_return + (link_str % (page, page))
+                to_return = to_return + "</div>"
+        except template.VariableDoesNotExist:
+            to_return = ''
+        return to_return
+
+register.tag('paginate', do_pagination)
+register.filter('letterlimit', letterlimit)
\ No newline at end of file
Index: django/contrib/databrowse/templatetags/databrowse.pyc
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: django/contrib/databrowse/templatetags/databrowse.pyc
___________________________________________________________________
Name: svn:mime-type
   + application/octet-stream

Index: django/contrib/databrowse/templatetags/__init__.py
===================================================================
Index: django/contrib/databrowse/templatetags/__init__.pyc
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: django/contrib/databrowse/templatetags/__init__.pyc
___________________________________________________________________
Name: svn:mime-type
   + application/octet-stream

Index: django/contrib/databrowse/templates/databrowse/calendar_fordate.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/calendar_fordate.html	(revision 0)
+++ django/contrib/databrowse/templates/databrowse/calendar_fordate.html	(revision 0)
@@ -0,0 +1,51 @@
+{% extends "databrowse/base.html" %}
+{% load databrowse %}
+
+{% block title %}{{ model.verbose_name_plural|capfirst }} with {{ field.verbose_name }} in {% if year %}{{ year }}{% else %}{% if month %}{{ month }}{% else %}{% if day %}{{ day }}{% endif %}{% endif %}{% endif %}{% endblock %}
+
+{% block content %}
+
+<div id="breadcrumbs">
+{% if day %}
+    <a href="../../../../../../../../">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../../../">Calendars</a> / <a href="../../../">By {{ field.verbose_name }}</a> / <a href="../../"> {{ year }}</a> / <a href="../">{{ month|capfirst }}</a> / {{ day }}
+{% else %}
+    {% if month %}
+        <a href="../../../../../../../">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../../../">Calendars</a> / <a href="../../../">By {{ field.verbose_name }}</a> / <a href="../../"> {{ year }}</a> / <a href="../">{{ month|capfirst }}</a> / objects
+    {% else %}
+        {% if year %}
+            <a href="../../../../../../">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../../">Calendars</a> / <a href="../../">By {{ field.verbose_name }}</a> / <a href="../">{{ year }}</a> / objects
+        {% else %}
+            <a href="../../../../../">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../">Calendars</a> / <a href="../">By {{ field.verbose_name }}</a> / objects
+        {% endif %}
+    {% endif %}
+{% endif %}
+</div>
+
+<h1>
+{{ model.verbose_name_plural|capfirst }}
+{% if day %}
+    with {{ field.verbose_name }} on {{ month|capfirst }} {{ day }}, {{ year }}
+{% else %}
+    {% if month %}
+        with {{ field.verbose_name }} in {{ month|capfirst }} of {{ year }}
+    {% else %}
+        {% if year %}
+            with {{ field.verbose_name }} in {{ year }}
+        {% else %}
+            by {{ field.verbose_name }}
+        {% endif %}
+    {% endif %}
+{% endif %}
+</h1>
+
+<ul class="objectlist">
+{% for object in object_list %}
+    <li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object }}</a></li>
+{% endfor %}
+</ul>
+
+{% if model.pagination %}
+    {% paginate model.pagination 2 %}
+{% endif %}
+
+{% endblock %}
Index: django/contrib/databrowse/templates/databrowse/calendar_month.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/calendar_month.html	(revision 5656)
+++ django/contrib/databrowse/templates/databrowse/calendar_month.html	(working copy)
@@ -1,17 +0,0 @@
-{% extends "databrowse/base.html" %}
-
-{% block title %}{{ model.verbose_name_plural|capfirst }} with {{ field.verbose_name }} in {{ month|date:"F Y" }}{% endblock %}
-
-{% block content %}
-
-<div id="breadcrumbs"><a href="{{ root_url }}">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../../">Calendars</a> / <a href="../../">By {{ field.verbose_name }}</a> / <a href="../">{{ month.year }}</a> / {{ month|date:"F" }}</div>
-
-<h1>{{ model.verbose_name_plural|capfirst }} with {{ field.verbose_name }} in {{ month|date:"F Y" }}</h1>
-
-<ul class="objectlist">
-{% for object in object_list %}
-<li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object }}</a></li>
-{% endfor %}
-</ul>
-
-{% endblock %}
Index: django/contrib/databrowse/templates/databrowse/fieldchoice_detail.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/fieldchoice_detail.html	(revision 5656)
+++ django/contrib/databrowse/templates/databrowse/fieldchoice_detail.html	(working copy)
@@ -1,4 +1,5 @@
 {% extends "databrowse/base.html" %}
+{% load databrowse %}
 
 {% block title %}{{ model.verbose_name_plural|capfirst|escape }} with {{ field.field.verbose_name|escape }} {{ value|escape }}{% endblock %}
 
@@ -14,4 +15,6 @@
 {% endfor %}
 </ul>
 
+{% paginate model.pagination 2 %}
+
 {% endblock %}
Index: django/contrib/databrowse/templates/databrowse/model_detail.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/model_detail.html	(revision 5656)
+++ django/contrib/databrowse/templates/databrowse/model_detail.html	(working copy)
@@ -1,4 +1,5 @@
 {% extends "databrowse/base.html" %}
+{% load databrowse %}
 
 {% block title %}{{ model.verbose_name_plural|capfirst }}{% endblock %}
 
@@ -16,4 +17,6 @@
 {% endfor %}
 </ul>
 
+{% paginate model.pagination 2 %}
+
 {% endblock %}
Index: django/contrib/databrowse/templates/databrowse/calendar_daterange.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/calendar_daterange.html	(revision 0)
+++ django/contrib/databrowse/templates/databrowse/calendar_daterange.html	(revision 0)
@@ -0,0 +1,55 @@
+{% extends "databrowse/base.html" %}
+{% load databrowse %}
+
+{% block title %}{{ model.verbose_name_plural|capfirst }} with {{ field.verbose_name }} in {% if year %}{{ year }}{% else %}{% if month %}{{ month }}{% else %}{% if day %}{{ day }}{% endif %}{% endif %}{% endif %}{% endblock %}
+
+{% block content %}
+
+<div id="breadcrumbs">
+{% if month %}
+    <a href="../../../../../../">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../../">Calendars</a> / <a href="../../">By {{ field.verbose_name }}</a> / <a href="../"> {{ year }}</a> / {{ month|capfirst }}
+{% else %}
+    {% if year %}
+        <a href="../../../../../">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../">Calendars</a> / <a href="../">By {{ field.verbose_name }}</a> / {{ year }}
+    {% else %}
+        <a href="../../../../">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../">Calendars</a> / By {{ field.verbose_name }}
+    {% endif %}
+{% endif %}
+</div>
+
+<h1>
+{{ model.verbose_name_plural|capfirst }} 
+{% if month %}
+    with {{ field.verbose_name }} in {{ month|capfirst }} of {{ year }}
+{% else %}
+    {% if year %}
+        with {{ field.verbose_name }} in {{ year }}
+    {% else %}
+        by {{ field.verbose_name }}
+    {% endif %}
+{% endif %}
+</h1>
+
+<ul class="objectlist">
+{% for date in date_list %}
+    {% if month %}
+        <li class="{% cycle odd,even %}"><a href="{{ date|date:"d"|lower }}">{{ date|date:"D d" }}</a></li>
+    {% else %}
+        {% if year %}
+            <li class="{% cycle odd,even %}">
+                <a href="{{ date|date:"F"|lower }}">{{ date|date:"F" }}</a><a href="{{ date|date:"F"|lower }}/objects" class="more">See Objects &rarr;</a>
+            </li>
+        {% else %}
+            <li class="{% cycle odd,even %}">
+                <a href="{{ date|date:"Y"|lower }}">{{ date|date:"Y" }}</a><a href="{{ date|date:"Y"|lower }}/objects" class="more">See Objects &rarr;</a>
+            </li>
+        {% endif %}
+    {% endif %}
+{% endfor %}
+</ul>
+
+{% if model.pagination %}
+    {% paginate model.pagination 2 %}
+{% endif %}
+
+{% endblock %}
Index: django/contrib/databrowse/templates/databrowse/homepage.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/homepage.html	(revision 5656)
+++ django/contrib/databrowse/templates/databrowse/homepage.html	(working copy)
@@ -1,4 +1,5 @@
 {% extends "databrowse/base.html" %}
+{% load databrowse %}
 
 {% block title %}Databrowse{% endblock %}
 
@@ -11,7 +12,7 @@
 	  <h2><a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a></h2>
 		<p>
 		{% for object in model.sample_objects %}
-			<a href="{{ object.url }}">{{ object }}</a>, 
+			<a href="{{ object.url }}">{{ object|letterlimit:"30" }}</a>, 
 		{% endfor %}
 			<a class="more" href="{{ model.url }}">More &rarr;</a>
 		</p>
Index: django/contrib/databrowse/templates/databrowse/fieldchoice_list.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/fieldchoice_list.html	(revision 5656)
+++ django/contrib/databrowse/templates/databrowse/fieldchoice_list.html	(working copy)
@@ -1,4 +1,5 @@
 {% extends "databrowse/base.html" %}
+{% load databrowse %}
 
 {% block title %}{{ model.verbose_name_plural|capfirst|escape }} by {{ field.field.verbose_name|escape }}{% endblock %}
 
@@ -14,4 +15,6 @@
 {% endfor %}
 </ul>
 
+{% paginate pagination 2 %}
+
 {% endblock %}
Index: django/contrib/databrowse/templates/databrowse/calendar_year.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/calendar_year.html	(revision 5656)
+++ django/contrib/databrowse/templates/databrowse/calendar_year.html	(working copy)
@@ -1,17 +0,0 @@
-{% extends "databrowse/base.html" %}
-
-{% block title %}{{ model.verbose_name_plural|capfirst }} with {{ field.verbose_name }} in {{ year }}{% endblock %}
-
-{% block content %}
-
-<div id="breadcrumbs"><a href="{{ root_url }}">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../">Calendars</a> / <a href="../">By {{ field.verbose_name }}</a> / {{ year }}</div>
-
-<h1>{{ model.verbose_name_plural|capfirst }} with {{ field.verbose_name }} in {{ year }}</h1>
-
-<ul class="objectlist">
-{% for month in date_list %}
-<li class="{% cycle odd,even %}"><a href="{{ month|date:"M"|lower }}/">{{ month|date:"F" }}</a></li>
-{% endfor %}
-</ul>
-
-{% endblock %}
Index: django/contrib/databrowse/templates/databrowse/calendar_day.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/calendar_day.html	(revision 5656)
+++ django/contrib/databrowse/templates/databrowse/calendar_day.html	(working copy)
@@ -1,17 +0,0 @@
-{% extends "databrowse/base.html" %}
-
-{% block title %}{{ model.verbose_name_plural|capfirst }} with {{ field.verbose_name }} {{ day|date:"F j, Y" }}{% endblock %}
-
-{% block content %}
-
-<div id="breadcrumbs"><a href="{{ root_url }}">Home</a> / <a href="{{ model.url }}">{{ model.verbose_name_plural|capfirst }}</a> / <a href="../../../../">Calendars</a> / <a href="../../../">By {{ field.verbose_name }}</a> / <a href="../../">{{ day.year }}</a> / <a href="../">{{ day|date:"F" }}</a> / {{ day.day }}</div>
-
-<h1>{{ model.verbose_name_plural|capfirst }} with {{ field.verbose_name }} on {{ day|date:"F j, Y" }}</h1>
-
-<ul class="objectlist">
-{% for object in object_list %}
-<li class="{% cycle odd,even %}"><a href="{{ object.url }}">{{ object }}</a></li>
-{% endfor %}
-</ul>
-
-{% endblock %}
Index: django/contrib/databrowse/templates/databrowse/base.html
===================================================================
--- django/contrib/databrowse/templates/databrowse/base.html	(revision 5656)
+++ django/contrib/databrowse/templates/databrowse/base.html	(working copy)
@@ -18,8 +18,11 @@
 .filter strong { color:#666; }
 /* OBJECT LISTS */
 .objectlist { clear:both; margin:0 -20px; color:#666; }
-.objectlist li a { display:block; padding:1em 20px; }
-.objectlist li a:hover { background:#5b80b2; color:#3B5572; color:#fff; text-decoration:none; }
+.objectlist li { display:block; padding:1em 20px; color: #5b80b2; }
+.objectlist li:hover { background:#5b80b2; color:#fff; }
+.objectlist li a { color: inherit; }
+.objectlist li a:hover { text-decoration: none; }
+.objectlist li a.more { margin-left: 1.2em; color:#999 }
 .related h2 { font-size: 1em; margin-bottom: 0.6em; }
 .related .objectlist li a { padding: 0.6em 20px; }
 .related .objectlist li.odd { background:#eee; }
@@ -47,6 +50,9 @@
 #header a:hover { text-decoration:underline; }
 /* CONTENT */
 #content { background:#fff; border-bottom:1px solid #ddd; padding:0 20px; }
+/* PAGINATION */
+#pagination { margin: auto auto auto auto; text-align: center; font-size: 1.2em; }
+#pagination .bold { font-weight: bold; }
 </style>
 </head>
 <body id="{% block bodyid %}page{% endblock %}">
Index: django/contrib/databrowse/sites.py
===================================================================
--- django/contrib/databrowse/sites.py	(revision 5656)
+++ django/contrib/databrowse/sites.py	(working copy)
@@ -59,7 +59,10 @@
         return plugin.model_view(request, self, rest_of_url)
 
     def main_view(self, request):
-        easy_model = EasyModel(self.site, self.model)
+        page = 0
+        if request.has_key('page'):
+            page = int(request.GET['page'])
+        easy_model = EasyModel(self.site, self.model, paginate_by = 100, page = page)
         html_snippets = u'\n'.join([p.model_index_html(request, self.model, self.site) for p in self.plugins.values()])
         return render_to_response('databrowse/model_detail.html', {
             'model': easy_model,